DROP TABLE INTRANET_CAL;
DROP TABLE INTRANET_USER_GROUPS;
DROP TABLE INTRANET_USERS;
DROP SEQUENCE SQ_intranet_cal;

CREATE TABLE INTRANET_USERS
(
        username VARCHAR(30) NOT NULL,
        password VARCHAR(30) NOT NULL
);

CREATE TABLE INTRANET_USER_GROUPS
(        username VARCHAR(30) NOT NULL,
        groupname VARCHAR(30) NOT NULL
);

ALTER TABLE INTRANET_USERS ADD CONSTRAINT INTRANET_USERS_PK PRIMARY KEY (username);
ALTER TABLE INTRANET_USER_GROUPS ADD CONSTRAINT INTRANET_USER_GROUPS_FK FOREIGN KEY (username) REFERENCES INTRANET_USERS ON DELETE CASCADE;

CREATE TABLE INTRANET_CAL
(
        id NUMBER (10, 0) NOT NULL,
        type NUMBER (2, 0) NOT NULL,
        owner VARCHAR(50) NOT NULL,
        start_date DATE,
        end_date DATE,
        subject VARCHAR(255) NOT NULL,
        description VARCHAR(255),
        location VARCHAR(255),
        status NUMBER (1, 0) NOT NULL,
        priority NUMBER (1, 0) NOT NULL,
        last_mod_by VARCHAR(50) NOT NULL,
        last_mod DATE NOT NULL,
        recurrence NUMBER (2, 0),
        r_until DATE,
        r_interval NUMBER (3, 0),
        r_dow_mask NUMBER (10, 0),
        r_instance NUMBER (10, 0)
);

CREATE SEQUENCE SQ_intranet_cal;

ALTER TABLE INTRANET_CAL ADD CONSTRAINT AUTH_PK PRIMARY KEY (id);
ALTER TABLE INTRANET_CAL ADD CONSTRAINT CALAUTHOWNER_FK FOREIGN KEY (owner) REFERENCES INTRANET_USERS ON DELETE CASCADE;
ALTER TABLE INTRANET_CAL ADD CONSTRAINT CALAUTHLASTMOD_FK FOREIGN KEY (last_mod_by) REFERENCES INTRANET_USERS ON DELETE CASCADE;

INSERT INTO INTRANET_USERS (username, password) VALUES ('name1', 'password1');
INSERT INTO INTRANET_USERS (username, password) VALUES ('name2', 'password2');
INSERT INTO INTRANET_USERS (username, password) VALUES ('global', 'global');
