/* 
 * UserGestureResponse.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.app;

import com.eXtropia.datahandler.DataHandlerException;
import com.eXtropia.util.ExtropiaException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class UserGestureResponse {
    public static final String REQUEST_PARAM_NAME = "gestureResponse";

    protected String _view;
    protected ExtropiaException _exception;
    protected DataHandlerException _dataHandlerException;

    /** Creates new UserGestureResponse */
    public UserGestureResponse() {

    }

    public UserGestureResponse(String view) {
        _view = view;
    }

    public UserGestureResponse(String view, ExtropiaException error) {
        _view = view;
        _exception = error;
    }

    public DataHandlerException getDataHandlerException() {
        return _dataHandlerException;
    }

    public ExtropiaException getError() {
        return _exception;
    }

    public String getView() {
        return _view;
    }

    public boolean hasError() {
        return _exception != null;
    }

    public void setDataHandlerException(DataHandlerException dhe) {
        _dataHandlerException = dhe;
    }

    public void setError(ExtropiaException ee) {
        _exception = ee;
    }

    public void setView(String view) {
        _view = view;
    }
}