/* 
 * Authenticator.java
 * Copyright (C) 2000 - 2001 eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth;

import java.util.Map;

import com.eXtropia.config.Configurable;
import com.eXtropia.util.ExtropiaException;

/** 
 *
 * @author Carlo Ravagli (carlo.ravagli@extropia.com)
 * @author Parijat Mishra
 * @version 1.2
 *
 * Internal Revision $Rewision$
 */

public interface Authenticator extends Configurable {
    public static final String CFG_BASE = "Authenticator";
    public static final String CFG_USERFAC_BASE = "Userfactory";
    public static final String CFG_ATTRIB_BASE = "Attribute";
    public static final String CFG_USER_BASE = "UserDatasource";
    public static final String CFG_GROUP_BASE = "GroupDatasource";
    public static final String CFG_PASSWORD_ENCRYPTION = "PasswordEncryption";

    public User authenticate(Object id, Object password) throws AuthException, ExtropiaException;
    public User register(Object id, Object password, Map regInfo) throws AuthException, ExtropiaException;
    public User getUser(Object id) throws AuthException, ExtropiaException;
    public User[] getMembers(String group) throws AuthException, ExtropiaException;
}
