/*
 * Encryptor.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Created on January 5, 2001, 1:59 PM
 */
package com.eXtropia.auth;

/**
 *
 * @author  parijat
 * @version 
 */
public interface Encryptor {
    /**
     * @return the name of the algoritm, such as MD5, SHA, DES, being used
     * for the encryption
     */
    public String getAlgorithm();

    /**
     * This method performs a similar function to the unix <em>passwd</em> command.
     * It takes in a plaintext password (for e.g., onbe typed in by a user), and
     * a encrypted string (such as stored in a database or the unix passwd file),
     * and checks if the cleartext password matches the encrypted one.
     * 
     * @arg clear password in cleartext
     * @arg enc   encrypted password
     * @return true if the cleartext password matches the encrypted one, false otherwise
     */
    public boolean match(String clear, String enc);

    /**
     * Takes a plaintext password and encrypts it
     * @return the encrypted value.
     */
    public String encrypt(String plaintext);
}
