/* 
 * SimpleUser.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class SimpleUser implements User {
    protected Object _userId;
    protected Object _password;

    protected List _groups = new ArrayList();
    protected Map _attributes = new HashMap();

    public SimpleUser(Object id) {
        _userId = id;
    }

    public Object getId() {
        return _userId;
    }

    public Object getPassword() {
        return _password;
    }

    public void setId(Object id) {
        _userId = id;
    }

    public void setPassword(Object pw) {
        _password = pw;
    }

    public String[] getGroupMemberships() {
        return (String[]) _groups.toArray(new String[_groups.size()]);
    }

    public void setGroupMemberships(String[] groups) {
        _groups.clear();
        for (int i = 0; i < groups.length; i++) {
            _groups.add(groups[i]);
        }
    }

    public boolean isMemberOf(String group) {
        return _groups.contains(group);
    }

    public void addGroupMembership(String group) {
        _groups.add(group);
    }

    public void removeGroupMembership(String group) {
        _groups.remove(group);
    }

    public void setAttribute(String attrib, Object value) {
        _attributes.put(attrib, value);
    }

    public Object getAttribute(String attrib) {
        return _attributes.get(attrib);
    }

    public void setAttributes(Map attributes) {
        _attributes.putAll(attributes);
    }

    public Map getAttributes() {
        return _attributes;
    }
}