/*
 * User.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth;

import java.util.Map;

import com.eXtropia.util.ExtropiaException;

/**
 *
 * @author  Carlo Ravagli (carlo.ravagli@extropia.com)
 * @author  Parijat Mishra (parijat@extropia.com)
 * @version 0.2
 *
 * Internal revision: $Revision: 1.10 $
 */
public interface User {
    // root config element
    public static final String CFG_BASE = "Userfactory";

    // mandatory attributes that every User implementation MUST support
    public static final String USER_ATTR_ID = "userid";
    public static final String USER_ATTR_PASSWORD = "password";
    public static final String USER_ATTR_GROUPS = "group";

    // accessor/mutator functions for the special attributes
    public Object getId();
    public Object getPassword();
    public void setPassword(Object password) throws AuthException, ExtropiaException;

    public boolean isMemberOf(String group);
    public void addGroupMembership(String group) throws AuthException, ExtropiaException;
    public void removeGroupMembership(String group) throws AuthException, ExtropiaException;
    public String[] getGroupMemberships();
    public void setGroupMemberships(String[] groups) throws AuthException, ExtropiaException;

    // accessor/mutators for 'normal' attributes
    public void setAttribute(String attrib, Object value) throws AuthException, ExtropiaException;
    public Object getAttribute(String attrib);

    public void setAttributes(Map attributes) throws AuthException, ExtropiaException;
    public Map getAttributes();
}
