/* 
 * AuthManagerUserGesture.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth.authmanager.formvar;

import java.util.HashMap;
import java.util.Map;

import com.eXtropia.app.UserGesture;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class AuthManagerUserGesture extends UserGesture {
    public static final String REQUEST_PARAM_AUTH_PREFIX = "auth_";
    public static final String REQUEST_PARAM_AUTH_USERNAME = REQUEST_PARAM_AUTH_PREFIX + "uid";
    public static final String REQUEST_PARAM_AUTH_PASSWORD = REQUEST_PARAM_AUTH_PREFIX + "pw";
    public static final String REQUEST_PARAM_AUTH_NEW_PASSWORD = REQUEST_PARAM_AUTH_PREFIX + "pw1";
    public static final String REQUEST_PARAM_AUTH_RELOGIN = REQUEST_PARAM_AUTH_PREFIX + "rl";
    public static final String REQUEST_PARAM_AUTH_REGISTRATION_STEP = REQUEST_PARAM_AUTH_PREFIX + "rs";

    protected Object _uid;
    protected Object _password;
    protected HashMap _appParams;
    protected Integer _registrationStep;

    public AuthManagerUserGesture(Object uid, Object password, Map appParams) {
        _uid = uid;
        _password = password;
        _appParams = (HashMap) appParams;
    }

    public Object getUsername() {
        return _uid;
    }

    public Object getPassword() {
        return _password;
    }

    public Map getRequestParams() {
        return (Map) _appParams.clone();
    }

    protected void setUsername(Object uid) {
        _uid = uid;
    }

    protected void setPassword(Object password) {
        _password = password;
    }

    public Integer getRegistrationStep() {
        return _registrationStep;
    }

    public void setRegistrationStep(Integer registrationStep) {
        _registrationStep = registrationStep;
    }
}