/* 
 * Register.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth.authmanager.formvar;

import java.util.Map;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.auth.User;
import com.eXtropia.datahandler.DataHandlerException;
import com.eXtropia.util.ExtropiaException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class Register extends AuthAction {
    public Register() {
        setRequiresAuthentication(false);
    }

    public UserGestureResponse execute(UserGesture g, ServletRequest request) throws ExtropiaException {
        AuthManagerUserGesture gesture = (AuthManagerUserGesture) g;
        AuthManagerUserGestureResponse response = new AuthManagerUserGestureResponse();
        Object username = gesture.getUsername();
        Map attributes = gesture.getData();

        Object password = (String) attributes.remove(AuthManagerUserGesture.REQUEST_PARAM_AUTH_NEW_PASSWORD);

        //check that the user does not already exist
        User user = null;
        if (username != null) //the authenticator may assign e usernames
            {
            //check that the user is not already registered
            user = _authenticator.getUser(username);
            if (user != null) {
                DataHandlerException dhe1 = new DataHandlerException("rule");
                DataHandlerException dhe2 = new DataHandlerException("widget");
                dhe1.addChild(dhe2);
                DataHandlerException dhe3 = new DataHandlerException(AuthManagerUserGesture.REQUEST_PARAM_AUTH_USERNAME);
                dhe2.addChild(dhe3);
                DataHandlerException dhe4 = new DataHandlerException("exists", AuthManagerUserGesture.REQUEST_PARAM_AUTH_USERNAME, username);
                dhe3.addChild(dhe4);
                response.setView(g.getView());
                response.setDataHandlerException(dhe1);
                return response;
            }
        }
        user = _authenticator.register(username, password, attributes);
        gesture.setView(null);
        response.setView(Views.REGISTRATION_SUCCESS);
        response.setUser(user);
        response.setNewRegisteredUser(true);
        return response;
    }
}