/* 
 * UserAttributeDataAccessor.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth.authmanager.formvar;

import javax.servlet.ServletRequest;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.auth.AuthManager;
import com.eXtropia.auth.User;
import com.eXtropia.view.WidgetDataAccessor;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class UserAttributeDataAccessor extends WidgetDataAccessor {
    boolean _nextCalled = false;
    protected User _user;

    public UserAttributeDataAccessor() {
    }

    public Object getValue(String key) {
        if (_user != null) {
            if (key.equals(AuthManagerUserGesture.REQUEST_PARAM_AUTH_USERNAME)) {
                return _user.getId();
            } else {

                return _user.getAttribute(key);
            }
        } else
            return null;
    }

    public boolean hasNext() {
        if (!_nextCalled) {
            if (_user != null) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    public void next() {
        _nextCalled = true;
    }

    public void setServletRequest(ServletRequest request) {
        super.setServletRequest(request);
        if (request instanceof HttpServletRequest) {
            HttpSession session = ((HttpServletRequest) _servletRequest).getSession(false);
            if (session != null)
                _user = (User) session.getAttribute(AuthManager.KEY_USER);
        }
        if (_user == null) {
            //we can also try to get the user from the gesture response object
            UserGestureResponse response = (UserGestureResponse) request.getAttribute(UserGestureResponse.REQUEST_PARAM_NAME);
            if (response != null && response instanceof AuthManagerUserGestureResponse) {
                _user = ((AuthManagerUserGestureResponse) response).getUser();
            }
        }
    }

    public String getIdSuffix() {
        return null;
    }
}