/* 
 * UserGestureFactory.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth.authmanager.formvar;

import java.util.Enumeration;
import java.util.HashMap;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class UserGestureFactory extends com.eXtropia.app.servlet.UserGestureFactory {
    public UserGestureFactory() {

    }

    public UserGesture create(ServletRequest request) {
        //System.out.println("Creating an AuthUserGesture");
        HashMap map = new HashMap();
        String key;
        String[] values;
        //generate a map of all the current request parameters
        for (Enumeration enum = request.getParameterNames(); enum.hasMoreElements();) {
            key = (String) enum.nextElement();
            if (!key.startsWith(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX)) {
                values = request.getParameterValues(key);
                //System.out.println("Adding persistent param: " + key + " => " + values);
                if (values.length > 1)
                    map.put(key, values);
                else
                    map.put(key, values[0]);
            }
        }

        String view = request.getParameter(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.VIEW_REQUEST_PARAM_NAME);
        //if(view != null)
        //	map.put(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.VIEW_REQUEST_PARAM_NAME, view);
        String username = request.getParameter(AuthManagerUserGesture.REQUEST_PARAM_AUTH_USERNAME);
        String password = request.getParameter(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PASSWORD);
        AuthManagerUserGesture gesture = new AuthManagerUserGesture(username, password, map);
        gesture.setView(view);
        String currentRequestParam, action;
        for (Enumeration requestParamNames = request.getParameterNames(); requestParamNames.hasMoreElements();) {
            currentRequestParam = (String) requestParamNames.nextElement();
            if (currentRequestParam.startsWith(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.ACTION_REQUEST_PARAM_NAME)) {
                action = currentRequestParam.substring((AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.ACTION_REQUEST_PARAM_NAME).length());
                //System.out.println("b: " + action);
                if (action != null && action.length() > 0) {
                    if (action.endsWith(".x") || action.endsWith(".y"))
                        action = action.substring(0, action.length() - 2);
                    //System.out.println("c: " + action);
                    gesture.setAction(action);
                }
                break;
            }
        }
        gesture.setTargetView(request.getParameter(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.TARGET_VIEW_REQUEST_PARAM_NAME));

        //if they are registering, there may a registration step parameter on the request
        try {
            Integer step = new Integer(request.getParameter(AuthManagerUserGesture.REQUEST_PARAM_AUTH_REGISTRATION_STEP));
            gesture.setRegistrationStep(step);
        } catch (Exception e) {
        } //no reg step specified
        return gesture;
    }
}