/* 
 * RegisterUrlTag.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.auth.authmanager.formvar.tags;

import java.util.Map;

import com.eXtropia.app.UserGesture;
import com.eXtropia.auth.authmanager.formvar.AuthManagerUserGesture;
import com.eXtropia.auth.authmanager.formvar.Views;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class RegisterUrlTag extends com.eXtropia.view.UrlNavigationTag {
    public Map getRequestParams() {
        UserGesture gesture = (UserGesture) pageContext.getRequest().getAttribute(UserGesture.REQUEST_PARAM_NAME);
        Map map;
        if (gesture instanceof AuthManagerUserGesture) {
            //System.out.println("Getting directly from gesture");
            map = gesture.getRequestParams();
        } else {
            //System.out.println("Getting params from super class");
            map = super.getRequestParams();
            map.remove(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.TARGET_VIEW_REQUEST_PARAM_NAME);
            map.remove(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.ACTION_REQUEST_PARAM_NAME);
        }
        /*Map.Entry entry;
        for(Iterator i= map.entrySet().iterator();i.hasNext();)
        {
        	entry= (Map.Entry)i.next();
        	System.out.println(entry.getKey() + " => " + entry.getValue());
        }*/
        map.put(AuthManagerUserGesture.REQUEST_PARAM_AUTH_PREFIX + UserGesture.VIEW_REQUEST_PARAM_NAME, Views.REGISTER);
        map.remove(AuthManagerUserGesture.ACTION_REQUEST_PARAM_NAME);
        return map;
    }
}