/* 
 * ServletRequestDataHandlerManager.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datahandler;

import javax.servlet.ServletRequest;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class ServletRequestDataHandlerManager extends DataHandlerManager {
    public Object getOriginalData(String key, Object originalData) throws IllegalArgumentException {
        try {
            String parameter = ((ServletRequest) originalData).getParameter(key);
            if (parameter == null || parameter.length() == 0)
                return null;
            else
                return parameter;
        } catch (ClassCastException cce) {
            throw new IllegalArgumentException("ServletRequestDataHandlerManager expects a ServletRequest not a " + originalData.getClass().getName());
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public void setOriginalData(String key, Object value, Object originalData) throws IllegalArgumentException {
        try {
            ((ServletRequest) originalData).setAttribute(key, value);
        } catch (ClassCastException cce) {
            throw new IllegalArgumentException("ServletRequestDataHandlerManager expects a ServletRequest not a " + originalData.getClass().getName());
        }
    }
}