/* 
 * BooleanHandler.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datahandler.handler;

import com.eXtropia.datahandler.DataHandler;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class BooleanHandler extends DataHandler {
    public static final String NAME = "boolean";

    public BooleanHandler() {
        super(NAME);
    }

    public Object validate(Object[] values) {
        for (int i = 0; i < values.length; i++) {
            if (values[i] == null)
                values[i] = Boolean.FALSE;
            else
                values[i] = Boolean.valueOf(values[0].toString());
        }
        return null;
    }
}