/* 
 * Set.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datahandler.handler;

import com.eXtropia.config.Config;
import com.eXtropia.config.ConfigException;
import com.eXtropia.datahandler.DataHandler;
import com.eXtropia.datahandler.DataHandlerException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0.1
 */
public class SetHandler extends DataHandler {
    public static final String CFG_SET_ITEM = "SetItem";

    private java.util.Set _set = new java.util.HashSet();

    public SetHandler() {
        super("set");
    }

    public void add(Object object) {
        _set.add(object);
    }

    public void configure(Config config) throws ConfigException {
        Config[] children = config.getChildren();
        for (int i = 0; i < children.length; i++) {
            if (children[i].getName().equals(CFG_SET_ITEM)) {
                add(config.getValue());
            }
        }
    }

    public Object validate(Object[] values) throws DataHandlerException {
        for (int i = 0; i < values.length; i++) {
            if (values[i] != null && !_set.contains(values[i]))
                throw new DataHandlerException(_name, _ids[i], values[i]);
        }
        return null;
    }
}