/* 
 * Condition.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datasource;

/** 
 *
 * @author Carlo Ravagli
 * @version 0.1
 */
public class Condition {
    private String _field;
    private int _operator;
    private Object _value;

    public static final int EQUAL = 0;
    public static final int NOT_EQUAL = 1;
    public static final int GREATER_OR_EQUAL = 2;
    public static final int GREATER_THAN = 3;
    public static final int LESS_OR_EQUAL = 4;
    public static final int LESS_THAN = 5;

    /** Creates new Condition */
    public Condition() {
        _field = null;
        _operator = EQUAL;
        _value = null;
    }

    public Condition(String field, int operator) {
        this(field, operator, null);
    }

    public Condition(String field, int operator, Object value) {
        if (field == null || field.length() == 0)
            throw new IllegalArgumentException();
        _field = field;
        _operator = operator;
        _value = value;
    }

    public void setField(String field) {
        if (field == null || field.length() == 0)
            throw new IllegalArgumentException();
        _field = field;
    }

    public String getField() {
        return _field;
    }

    public void setOperator(int operator) {
        _operator = operator;
    }

    public int getOperator() {
        return _operator;
    }

    public void setValue(Object value) {
        _value = value;
    }

    public Object getValue() {
        return _value;
    }
}