/* 
 * FieldOrder.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datasource;

/** 
 *
 * @author  Carlo Ravagli (carlo.ravagli@extropia.com)
 * @version 0.1
 */

public class FieldOrder extends Object {
    public static final int ASCEND = 1;
    public static final int DESCEND = 2;

    private String _field;
    private int _order;

    /** Creates new ResultOrder */
    public FieldOrder() {
        _field = null;
        _order = ASCEND;
    }

    public FieldOrder(String field) {
        this(field, ASCEND);
    }

    public FieldOrder(String field, int order) {
        if (field == null || field.length() == 0)
            throw new IllegalArgumentException();
        _field = field;
        _order = order;
    }

    public void setField(String field) throws IllegalArgumentException {
        if (field == null || field.length() == 0)
            throw new IllegalArgumentException();
        _field = field;
    }

    public String getField() {
        return _field;
    }

    public void setOrder(int order) {
        _order = order;
    }

    public int getOrder() {
        return _order;
    }
}