/* 
 * ColMetaData.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datasource.jdbc;

import java.sql.Types;

/** 
 *
 * @author  Carlo Ravagli (carlo.ravagli@extropia.com)
 * @version 0.1
 */
class ColMetaData {
    private String _name;
    private int _sqlType;
    private boolean _searchable = true;
    private boolean _keywordSearchable = false;
    private boolean _autoIncrement = false;
    private boolean _caseInsensitive = false;
    private String _defaultValue = null;

    /** Creates new ColMetaData */
    ColMetaData() {
        _sqlType = Types.NULL;
    }

    void setName(String name) {
        _name = name;
    }

    public String getName() {
        return _name;
    }

    void setSqlType(int type) {
        _sqlType = type;
    }

    public int getSqlType() {
        return _sqlType;
    }

    void setSearchable(boolean searchable) {
        _searchable = searchable;
    }

    public boolean isSearchable() {
        return _searchable;
    }

    void setKeywordSearchable(boolean keywordSearchable) {
        _keywordSearchable = keywordSearchable;
    }

    public boolean isKeywordSearchable() {
        return _keywordSearchable && _searchable;
    }

    void setAutoIncrement(boolean autoIncrement) {
        _autoIncrement = autoIncrement;
    }

    public boolean isAutoIncrement() {
        return _autoIncrement;
    }

    void setDefaultValue(String s) {
        _defaultValue = s;
    }

    public String getDefaultValue() {
        return _defaultValue;
    }

    void setCaseInsensitive(boolean caseInsensitive) {
        _caseInsensitive = caseInsensitive;
    }

    public boolean isCaseInsensitive() {
        return _caseInsensitive;
    }
}