/* 
 * SqlValue.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datasource.jdbc;

import java.sql.Types;

/** 
 *
 * @author  Carlo Ravagli (carlo.ravagli@extropia.com)
 * @version 0.1
 */
class SqlValue {
    private Object _value;
    private int _sqlType;

    public SqlValue(Object value, int sqlType) {
        if (value != null) {
            switch (sqlType) {
                case Types.DATE :
                    if (value instanceof java.util.Date && !(value instanceof java.sql.Date))
                        value = new java.sql.Date(((java.util.Date) value).getTime());
                    break;
                case Types.TIME :
                    if (value instanceof java.util.Date && !(value instanceof java.sql.Time))
                        value = new java.sql.Time(((java.util.Date) value).getTime());
                    break;
                case Types.TIMESTAMP :
                    if (value instanceof java.util.Date && !(value instanceof java.sql.Timestamp))
                        value = new java.sql.Timestamp(((java.util.Date) value).getTime());
                    break;
            }
        }

        _value = value;
        _sqlType = sqlType;
    }

    public Object getValue() {
        return _value;
    }

    public int getType() {
        return _sqlType;
    }
}