/* 
 * ExceedingQuotaException.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.datasource.secure;

import com.eXtropia.util.ExtropiaException;

/** 
 *
 * @author Carlo Ravagli
 * @version 1.0
 */
public class QuotaException extends SecureDataSourceException {
    protected int _quota;
    /**
    * Creates new <code>ExceedingQuotaException</code> without detail message.
    */

    public QuotaException(String msg) {
        super(msg);
    }

    public QuotaException(int quota) {
        _quota = quota;
    }

    /**
    * Constructs an <code>ExceedingQuotaException</code> with the specified detail message.
    * and the quota value.
    * @param msg the detail message.
    */
    public QuotaException(String msg, int quota) {
        super(msg);
        _quota = quota;
    }

    /**
    * Constructs an <code>DataSourceException</code> with the specified detail message
    * and a child exception.
    * @param msg the detail message.
    * @param child the child exception.
    */
    public QuotaException(String msg, int quota, ExtropiaException child) {
        super(msg, child);
        _quota = quota;
    }

    public int getQuota() {
        return _quota;
    }
}
