/* 
 * DiagnosticsEvent.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.diagnostics;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0.1
 */
class DiagnosticsEvent extends java.util.EventObject {
    private Doctor _doctor;
    public static final short TRACE = 0;
    public static final short LOG = 1;
    short _type;

    /** Creates new DiagnosticsEvent */
    public DiagnosticsEvent(Object source, short type) {
        super(source);
        _type = type;
    }

    public void setDoctor(Doctor doctor) {
        _doctor = doctor;
    }

    public Doctor getDoctor() {
        return _doctor;
    }

    public String getFilterString() {
        String[] filters = _doctor.getFilters();
        String result = "";
        for (int i = 0; i < filters.length; i++) {
            result += filters[i] + "=>";
        }
        return result.substring(0, result.length() - 2);

    }
}