/* 
 * SystemOut.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.diagnostics;

/** 
 * A class that logs {@link TraceEvent} and{@link LogEvent} to <CODE>System.out</CODE>
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0.1
 */
public class SystemOutListener extends ListenerSupport implements LogListener, TraceListener {
    /** Creates new SystemOut */
    public SystemOutListener() {

    }

    /**
     * Logs the specified <CODE>LogEvent</CODE> to System.out
     */
    public void log(LogEvent logEvent) {
        if (okLogLevel(logEvent.getLevel())) {
            System.out.println(formatMessage(logEvent.getMessage(), logEvent.getLevelName(), logEvent.getMap()));
        }
    }

    /**
     * Traces the specified <CODE>TraceEvent</CODE> to System.out
     */
    public void trace(TraceEvent traceEvent) {
        if (okTraceLevel(traceEvent.getLevel())) {
            System.out.println(formatMessage(traceEvent.getMessage(), traceEvent.getLevelName(), null));
            if (traceEvent.getException() != null) {
                traceEvent.getException().printStackTrace(System.out);
            }
        }
    }
}