/* 
 * ScheduledSms.java
 * Copyright (C) 2000  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.sms;

import java.util.Date;

/**
 * The SMS message object with Date options
 *
 * @author <a href="mailto:carlo@eXtropia.com">Carlo Ravagli</a>
 * @author <a href="mailto:st_lim@eXtropia.com">Lim Swee Tat</a>
 * @version $Id: ScheduledSms.java,v 1.3 2002/11/16 08:45:12 rayfd Exp $
 */
public class ScheduledSms extends Sms {
    private int _scheduled;
    private Date _date;

    /**
     * Creates a new <code>ScheduledSms</code> instance.
     *
     */
    public ScheduledSms() {
        super();
        _scheduled = 0;
    }

    /**
     * Describe <code>setDate</code> method here.
     *
     * @param date a <code>Date</code> value
     */
    public void setDate(Date date) {
        _date = date;
        _scheduled = 1;
    }

    /**
     * Describe <code>getSchedule</code> method here.
     *
     * @return a <code>Date</code> value
     */
    public Date getDate() {
        return _date;
    }

    /**
     * Describe <code>getScheduled</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int getScheduled() {
        return _scheduled;
    }

    /**
     * Describe <code>setScheduled</code> method here.
     *
     * @param scheduled an <code>int</code> value
     */
    public void setScheduled(int scheduled) {
        _scheduled = scheduled;
    }
} // ScheduledSms.java
