/*
 *  Sms.java
 *  Copyright (C) 2000  eXtropia.com
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.sms;

import java.io.Serializable;

/**
 *  The SMS message object 1.3 Added for more than one "to" address, assuming
 *  adds only
 *
 * @author     <a href="mailto:carlo@eXtropia.com">Carlo Ravagli</a>
 * @author     <a href="mailto:st_lim@eXtropia.com">Lim Swee Tat</a>
 * @created    June 19, 2002
 * @version    $Id: Sms.java,v 1.12 2002/11/16 08:45:12 rayfd Exp $
 */
public class Sms implements Serializable, Cloneable {
    /**  Description of the Field */
    public final static int TYPE_NONE = 0;

    private String _to;
    private String _from;
    private String _text;
    private int _type;

    /**  Creates a new <code>Sms</code> instance. */
    public Sms() {
    }

    /**
     *  Description of the Method
     *
     * @return                                 Description of the Return Value
     * @exception  CloneNotSupportedException  Description of the Exception
     */
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }

    /**
     *  Creates a new <code>Sms</code> instance.
     *
     * @param  to    an <code>String</code> value
     * @param  from  an <code>String</code> value
     * @param  text  a <code>String</code> value
     * @param  type  an <code>int</code> value
     */
    public Sms(String to, String from, String text, int type) {
        _to = to;
        _from = from;
        _text = text;
        _type = type;
    }

    /**
     *  Describe <code>getText</code> method here.
     *
     * @return    a <code>String</code> value
     */
    public String getText() {
        return _text;
    }

    /**
     *  Describe <code>setText</code> method here.
     *
     * @param  text  a <code>String</code> value
     */
    public void setText(String text) {
        _text = text;
    }

    /**
     *  Describe <code>getTo</code> method here.
     *
     * @return    an <code>String</code> value
     */
    public String getTo() {
        return _to;
    }

    /**
     *  Describe <code>setTo</code> method here.
     *
     * @param  to  an <code>String</code> value
     */
    public void setTo(String to) {
        _to = to;
    }

    /**
     *  Describe <code>getFrom</code> method here.
     *
     * @return    an <code>String</code> value
     */
    public String getFrom() {
        return _from;
    }

    /**
     *  Describe <code>setFrom</code> method here.
     *
     * @param  from  an <code>String</code> value
     */
    public void setFrom(String from) {
        _from = from;
    }

    /**
     *  Describe <code>getType</code> method here.
     *
     * @return    an <code>int</code> value
     */
    public int getType() {
        return _type;
    }

    /**
     *  Describe <code>setType</code> method here.
     *
     * @param  type  an <code>int</code> value
     */
    public void setType(int type) {
        _type = type;
    }
}
