/*
 * HtmlEncoder.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.util;

/**
 * @author <a href="mailto:yllee@eXtropia.com">Lee Yeow Leong</a>
 * @version $Id: HtmlEncoder.java,v 1.7 2002/11/16 08:45:13 rayfd Exp $
 */
public class HtmlEncoder {

    public static final String encode(String str) {
        char content[] = new char[str.length()];
        str.getChars(0, str.length(), content, 0);

        boolean found = false;

        for (int i = 0; i < content.length && !found; i++) {
            switch (content[i]) {
                case '<' :
                case '>' :
                case '&' :
                case '"' :
                case ' ' :
                case '\'' :
                    found = true;
                    break;
            }
        }

        if (found) {
            StringBuffer result = new StringBuffer(content.length + 50);
            for (int i = 0; i < content.length; i++) {
                switch (content[i]) {
                    case '\'' :
                        result.append("&apos;");
                        break;
                    case '<' :
                        result.append("&lt;");
                        break;
                    case '>' :
                        result.append("&gt;");
                        break;
                    case '&' :
                        result.append("&amp;");
                        break;
                    case '"' :
                        result.append("&quot;");
                        break;
                    case ' ' :
                        result.append("&nbsp;");
                        break;
                    default :
                        result.append(content[i]);
                }
            }
            return result.toString();
        }
        return str;
    }
}
