/* 
 * ActionPermissionTag.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.servlet.ActionAccessControlList;
import com.eXtropia.auth.User;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class ActionPermissionTag extends BodyTagSupport {
    protected String _action;

    public ActionPermissionTag() {

    }

    public int doStartTag() throws JspException {
        UserGesture gesture = (UserGesture) pageContext.getRequest().getAttribute(UserGesture.REQUEST_PARAM_NAME);
        User user = gesture.getUser();
        ActionAccessControlList acl = (ActionAccessControlList) pageContext.getRequest().getAttribute(ActionAccessControlList.REQUEST_ATTRIBUTE_NAME);
        if (acl.canExecute(user, _action))
            return EVAL_BODY_TAG;
        else
            return SKIP_BODY;
    }

    public int doEndTag() throws JspException {
        if (bodyContent != null) {
            try {
                bodyContent.getEnclosingWriter().write(bodyContent.getString());
            } catch (IOException e) {
                throw new JspException("IOException: " + e.getMessage());
            }
        }
        return EVAL_PAGE;
    }

    public void setAction(String action) {
        _action = action;
    }

    public void release() {
        _action = null;
    }
}