/*
 * DefaultWidgetDataAccessor.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import com.eXtropia.diagnostics.Diagnostics;
import com.eXtropia.diagnostics.Doctor;
import com.eXtropia.diagnostics.TraceEvent;

/**
 * @version $Revision: 1.4 $
 */
public class DefaultWidgetDataAccessor extends com.eXtropia.view.WidgetDataAccessor {
    private int _index = -1;
    protected Doctor _doctor = Diagnostics.getDoctor(new String[] { "FormDataAccessor" });

    public DefaultWidgetDataAccessor() {
    }

    public Object getValue(String str) {
        if (_data == null)
            return null;
        String value = (String) _data[_index].get(str.trim());
        if (value == null) {
            if (_doctor.doTrace(TraceEvent.DEVELOPER)) {
                _doctor.trace(new TraceEvent(this, TraceEvent.DEVELOPER, "FormDataAccessor Attribute: " + str + " value was null."));
            }
            value = "";
        }
        return value;
    }

    public boolean hasNext() {
        if (_data == null)
            return false;
        if (_index + 1 < _data.length)
            return true;
        else
            return false;
    }

    public void next() {
        if (_data == null)
            return;
        _index++;
    }

    public String getIdSuffix() {
        // what this method doing????
        return null;
    }
}
