/*
 * ElseTag.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class ElseTag extends BodyTagSupport {
    public ElseTag() {

    }

    public int doStartTag() throws JspException {
        //anderson - bug fix for JRun
        bodyContent = null;

        ConditionTag tag = (ConditionTag) findAncestorWithClass(this, ConditionTag.class);
        if (tag == null)
            throw new JspException("ElseTag must be nesting in a ConditionTag");
        if (!tag.condition())
            return EVAL_BODY_TAG;
        else
            return SKIP_BODY;
    }

    public int doEndTag() throws JspException {
        try {
            if (bodyContent != null) {
                bodyContent.writeOut(bodyContent.getEnclosingWriter());
            }
        } catch (Exception e) {
            throw new JspException("Exception: " + e.getMessage());
        }
        return EVAL_PAGE;
    }
}
