/*
 * FormTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0.1
 */
public class FormTag extends BodyTagSupport {
    public String _formType = "GET";
    public String _name;
    public String _enctype;
    //anderson - add the extraAttributes
    protected String _extraAttributes;
    private String _action;

    public FormTag() {
    }

    public String getAction() {
        return _action;
    }

    public void setAction(String action) {
        this._action = action;
    }

    public String getMethod() {
        return _formType;
    }

    public void setMethod(String type) {
        _formType = type;
    }

    public String getName() {
        return _name;
    }

    public void setName(String name) {
        _name = name;
    }

    public void setEnctype(String enctype) {
        _enctype = enctype;
    }

    public String getEnctype() {
        return _enctype;
    }

    public int doStartTag() throws JspException {
        //write out the form header
        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
        HttpServletResponse response = (HttpServletResponse) pageContext.getResponse();

        try {
            //pageContext.getOut().write("<FORM " + (request == null?"":"ACTION=\"" + response.encodeURL(request.getRequestURI()) + "\" ") + "METHOD=\"" + _formType + (_name==null?"":"\" NAME=\"" + _name) + (_enctype==null?"\">":"\" ENCTYPE=\"" + _enctype + "\">"));
            //anderson - add the information for the extraAttributes
            StringBuffer sb = new StringBuffer();

            // use action attribute if it is specified
            // this is to cater for the case where the reverse proxy name is not the same as the
            // application name
            sb.append("<FORM ").append("ACTION=\"").append(_action == null ? response.encodeURL(request.getRequestURI()) : response.encodeURL(_action)).append("\" ").append("METHOD=\"").append(_formType).append("\"");

            if (_name != null) {
                sb.append(" NAME=\"").append(_name).append("\"");
            }

            if (_enctype != null) {
                sb.append(" ENCTYPE=\"").append(_enctype).append("\"");
            }

            if (_extraAttributes == null) {
                sb.append(">");
            } else {
                sb.append(" ").append(_extraAttributes).append(">");
            }

            pageContext.getOut().write(sb.toString());
        } catch (Exception e) {
            throw new JspException("Exception: " + e.getMessage());
        }
        return EVAL_BODY_TAG;
    }

    public int doEndTag() throws JspException {
        try {
            if (bodyContent != null) {
                bodyContent.writeOut(bodyContent.getEnclosingWriter());
            }
            pageContext.getOut().write("</FORM>");
        } catch (Exception e) {
            throw new JspException("Exception: " + e.getMessage());
        }
        return EVAL_PAGE;
    }

    //anderson
    public String getExtraAttributes() {
        return _extraAttributes;
    }

    //anderson
    public void setExtraAttributes(String s) {
        _extraAttributes = s;
    }
}
