/* 
 * ListChunk.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

/** 
 * Abstract class that subclasses use where the array they hold represents a portion of the complete information
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public abstract class ListChunk {
    protected int _offset;
    protected int _pageSize;
    protected int _total;

    public ListChunk(int offset, int pageSize, int total) {
        _offset = offset;
        _pageSize = pageSize;
        _total = total;
    }

    public int getOffset() {
        return _offset;
    }

    public int getPageSize() {
        return _pageSize;
    }

    public int getTotal() {
        return _total;
    }
}