/* 
 * ListChunkDetailsTag.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import com.eXtropia.app.UserGestureResponse;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public abstract class ListChunkDetailsTag extends TagSupport {
    protected static final int START = 109757538; /* start */
    protected static final int END = 100571; /* end */
    protected static final int PAGESIZE = 860381968; /* pagesize */
    protected static final int TOTAL = 110549828; /* total */

    protected abstract ListChunk getChunk();
    protected String _property;
    protected UserGestureResponse _gestureResponse;

    public ListChunkDetailsTag() {

    }

    public int doStartTag() throws JspException {
        _gestureResponse = (UserGestureResponse) pageContext.getRequest().getAttribute(UserGestureResponse.REQUEST_PARAM_NAME);
        return SKIP_BODY;
    }

    public int doEndTag() throws JspException {
        ListChunk chunk = getChunk();
        String chunkProperty;
        switch (_property.hashCode()) {
            case TOTAL :
                chunkProperty = "" + chunk.getTotal();
                break;
            case START :
                chunkProperty = "" + (chunk.getOffset() + 1);
                break;
            case END :
                int end = chunk.getOffset() + chunk.getPageSize();
                if (end > chunk.getTotal())
                    end = chunk.getTotal();
                chunkProperty = "" + end;
                break;
            case PAGESIZE :
                chunkProperty = "" + chunk.getPageSize();
                break;
            default :
                throw new JspException("Unknown property (" + _property + "(. Use total, start, end & pagesize only");
        }
        try {
            pageContext.getOut().write(chunkProperty);
        } catch (IOException ioe) {
            throw new JspException("IOException: " + ioe.getMessage());
        }
        return EVAL_PAGE;
    }

    public void setProperty(String property) {
        _property = property;
    }

    public void release() {
        _property = null;
    }
}
