/* 
 * LocalizedStringTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.io.IOException;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import com.eXtropia.app.servlet.ServletUtils;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class LocalizedStringTag extends TagSupport {
    protected String _id;

    public LocalizedStringTag() {

    }

    public int doEndTag() throws JspException {
        //get the title of the page from the resource bundle
        Locale locale = (Locale) pageContext.getSession().getAttribute(ServletUtils.SESSION_ATTRIBUTE_LOCALE);
        View view = (View) pageContext.getRequest().getAttribute(ViewManager.VIEW_ATTRIBUTE_NAME);
        ResourceBundle bundle = ResourceBundle.getBundle(view.getResourceLocation(), locale);
        String localizedString = _id;
        try {
            localizedString = bundle.getString(_id);
        } catch (Exception e) {
        }
        try {
            pageContext.getOut().write(localizedString);
        } catch (IOException ioe) {
            throw new JspException("IOException: " + ioe.getMessage());
        }

        return EVAL_PAGE;
    }

    public String getId() {
        return _id;
    }

    public void setId(String id) {
        _id = id;
    }

    public void release() {
        _id = null;
    }
}