/* 
 * NextPageTag.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.util.Map;

import javax.servlet.jsp.JspException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public abstract class NextPageTag extends UrlNavigationTag {
    private Integer _offset;

    protected abstract ListChunk getChunk();
    protected abstract String getOffsetRequestParam();
    protected abstract String getPageSizeRequestParam();

    public NextPageTag() {

    }

    public Map getRequestParams() {
        Map map = super.getRequestParams();
        map.put(getOffsetRequestParam(), _offset);
        return map;
    }

    public int doEndTag() throws JspException {
        ListChunk chunk = getChunk();
        int offset = chunk.getOffset();
        int totalSize = chunk.getTotal();
        int pageSize = chunk.getPageSize();
        if (offset + pageSize < totalSize) {
            _offset = new Integer(offset + pageSize);
            return super.doEndTag();
        } else
            return EVAL_PAGE;
    }

    public void release() {
        _offset = null;
    }
}