/*
 * NextTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0,1
 */
public class NextTag extends BodyTagSupport {
    private Iterator _parent;
    private Object _obj;
    public static final String REQUEST_ATTRIBUTE_NAME = "NextTag";

    /** Creates new ColumnTag */
    public NextTag() {

    }

    public int doStartTag() throws JspException {
        Tag tag = this;
        // Stuff has to be initialized in doStartTag because of
        // Jrun 3.1 caching widgets that are previously created...
        _parent = null;
        _obj = null;
        bodyContent = null;
        while (tag != null && !(tag instanceof Iterator)) {
            tag = tag.getParent();
        }
        if (tag == null) {
            return SKIP_BODY;
        } else {
            _parent = (Iterator) tag;
        }
        if (_parent.hasNext()) {
            _obj = _parent.next();
            pageContext.getRequest().setAttribute(REQUEST_ATTRIBUTE_NAME, _obj);
            return EVAL_BODY_TAG;
        } else {
            return SKIP_BODY;
        }
    }

    public int doEndTag() throws JspException {
        try {
            if (bodyContent != null) {
                bodyContent.writeOut(bodyContent.getEnclosingWriter());
            }
        } catch (Exception e) {
            throw new JspException("IO Error: " + e.getMessage());
        }
        return EVAL_PAGE;
    }

    public Object getObject() {
        return _obj;
    }

    public Iterator getIterator() {
        return _parent;
    }
}