/*
 * NoNextTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

/**
 *
 * @author  Gunther Birznieks (gunther.birznieks@eXtropia.com)
 * @version 1
 */
public class NoNextTag extends BodyTagSupport {
    private Iterator _parent;
    public static final String REQUEST_ATTRIBUTE_NAME = "NoNextTag";

    /** Creates new ColumnTag */
    public NoNextTag() {

    }

    public int doStartTag() throws JspException {
        //System.out.println("Start Tag2");
        Tag tag = this;
        while (tag != null && !(tag instanceof Iterator)) {
            tag = tag.getParent();
        }
        if (tag == null) {
            return EVAL_BODY_TAG;
        } else {
            _parent = (Iterator) tag;
        }
        if (!_parent.hasNext()) {
            // Commented out from next tag...
            //_obj= _parent.next();
            //pageContext.getRequest().setAttribute(REQUEST_ATTRIBUTE_NAME, _obj);
            //System.out.println("EVAL_BODY_TAG");
            return EVAL_BODY_TAG;
        } else {
            //System.out.println("SKIP_BODY");
            return SKIP_BODY; // skips if the iterator has a next...
        }
    }

    public int doEndTag() throws JspException {
        try {
            if (bodyContent != null) {
                bodyContent.writeOut(bodyContent.getEnclosingWriter());
            }
        } catch (Exception e) {
            throw new JspException("IO Error: " + e.getMessage());
        }
        return EVAL_PAGE;
    }

    public Iterator getIterator() {
        return _parent;
    }
}