/*
 * View.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.util.Iterator;
import java.util.Map;

import com.eXtropia.datahandler.DataHandlerManager;
import com.eXtropia.view.widget.Widget;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class View implements Cloneable {
    public static final String RESOURCE_BASE = "view.";
    public static final String RESOURCE_TITLE = ".title";

    private String _name;
    private String _location;
    private Map _widgets;
    //TODO: allow widgets to have a data accessor ties to them
    //private Class [] _requiredDataAccessors;

    private DataHandlerManager _dataHandlerManager;

    private String[] _widgetOrder;
    private String _resourceLocation;
    private Map _attributes;

    public View(String name, String location, String resourceLocation, Map widgets, String[] widgetOrder, Map attributes) {
        _name = name;
        _location = location;
        _resourceLocation = resourceLocation;
        _widgets = widgets;
        _widgetOrder = widgetOrder;
        _attributes = attributes;
        //TODO: allow widgets to have a data accessor ties to them
        /*(_widgets != null)
        {
        	Widget widget;
        	List accessors= new ArrayList();
        	for(Iterator i=_widgets.entrySet().iterator();i.hasNext();)
        	{
        		widget= (Widget)((Map.Entry)i.next()).getValue();
        		if(widget.getDataAccessorClass() != null)
        			accessors.add(widget.getDataAccessorClass());
        	}
        	if(accessors.size() > 0)
        		_requiredDataAccessors= (Class[])accessors.toArray(new Class[accessors.size()]);
        }*/
    }

    public String getLocation() {
        return _location;
    }

    public String getName() {
        return _name;
    }

    public String[] getWidgetOrder() {
        return _widgetOrder;
    }

    public Widget getWidget(String widgetName) {
        //anderson - modified to utlize the index on 'id' & 'name'
        //return (Widget)_widgets.get(widgetName);
        Widget widget = (Widget) _widgets.get("id_" + widgetName);
        if (widget == null)
            widget = (Widget) _widgets.get("name_" + widgetName);
        return widget;
    }

    public String getResourceLocation() {
        return _resourceLocation;
    }

    public Object getAttribute(String key) {
        if (_attributes.get(key) == null) {
            System.out.println(_attributes);
        }
        return _attributes.get(key);
    }

    //TODO: allow widgets to have a data accessor ties to them
    /*blic Class [] getRequiredDataAccessors()
    {
    	return _requiredDataAccessors;
    }*/

    public void printWidgetNames() {
        //System.out.println("Widgets: " + _widgets.size());
        for (Iterator i = _widgets.entrySet().iterator(); i.hasNext();) {
            Map.Entry entry = (Map.Entry) i.next();
            //System.out.println("Widget in map: " + entry.getKey());
        }
    }
}