/*
 * WidgetDataAccessor.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view;

import java.util.Map;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public abstract class WidgetDataAccessor {
    protected UserGesture _gesture;
    protected UserGestureResponse _gestureResponse;
    protected ServletRequest _servletRequest;
    protected Map[] _data;

    protected boolean _accessed;

    public abstract Object getValue(String key);
    public abstract String getIdSuffix();
    public abstract boolean hasNext();
    public abstract void next();

    public WidgetDataAccessor() {
    }

    public boolean accessed() {
        return _accessed;
    }

    protected void setUserGesture(UserGesture gesture) {
        _gesture = gesture;
    }

    protected void setUserGestureResponse(UserGestureResponse gestureResponse) {
        _gestureResponse = gestureResponse;
    }

    public void setServletRequest(ServletRequest request) {
        _servletRequest = request;
        UserGesture gesture = (UserGesture) _servletRequest.getAttribute(UserGesture.REQUEST_PARAM_NAME);
        setUserGesture(gesture);
        UserGestureResponse gestureResponse = (UserGestureResponse) _servletRequest.getAttribute(UserGestureResponse.REQUEST_PARAM_NAME);
        setUserGestureResponse(gestureResponse);
    }

    public void setResource(Map[] data) {
        _data = data;
    }
}
