/* 
 * TrueFalseText.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget;

import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.ServletRequest;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class TrueFalseText extends Widget {
    public static final String RESOURCE_BUNDLE_TRUE = ".true";
    public static final String RESOURCE_BUNDLE_FALSE = ".false";

    public TrueFalseText() {
    }

    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        return toString(locale, value, request);
    }

    public String toString(Locale locale, Object value, ServletRequest request) {
        if (value == null)
            value = Boolean.FALSE;
        else if (!(value instanceof Boolean))
            value = Boolean.valueOf(value.toString());

        boolean realValue = ((Boolean) value).booleanValue();

        ResourceBundle bundle = ResourceBundle.getBundle(_resourceLocation, locale);
        String res;
        try {
            if (realValue)
                res = bundle.getString(_resourceBase + RESOURCE_BUNDLE_TRUE);
            else
                res = bundle.getString(_resourceBase + RESOURCE_BUNDLE_FALSE);
        } catch (Exception e) {
            if (realValue)
                res = "True";
            else
                res = "False";
        }
        return res;
    }
}