/* 
 * Checkbox.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.util.Locale;

import javax.servlet.ServletRequest;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class Checkbox extends HtmlInput {
    /** Creates new Checkbox */
    public Checkbox() {
        super("CHECKBOX");
    }

    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        value = selectValueToUse(value, request);
        if (value == null && _default)
            value = getDefaultValue(locale);

        StringBuffer buffer = new StringBuffer(50);
        buffer.append("<INPUT TYPE=\"");
        buffer.append(_type);
        buffer.append("\" NAME=\"");
        buffer.append(_id);
        buffer.append("\" VALUE=\"");
        buffer.append((value == null ? "" : value.toString()) + "\"");
        if (idSuffix != null && idSuffix.equals("true"))
            buffer.append(" CHECKED");
        appendAttributes(buffer);
        buffer.append('>');
        return buffer.toString();
    }
}