/* 
 * DateMultiTextInput.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.ServletRequest;

/**
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class DateMultiTextInput extends MultiTextInput {
    private static final DateFormat DATE_FORMAT = new SimpleDateFormat("ddMMyyyy");

    protected Object selectValueToUse(int i, Object value, ServletRequest request) {
        Object requestValue = request.getAttribute(_id + "_" + i);
        if (requestValue == null)
            requestValue = request.getParameter(_id + "_" + i);
        if (requestValue != null)
            return requestValue;
        else {
            if (value == null)
                return null;

            String strDate;
            if (value instanceof Date)
                strDate = DATE_FORMAT.format((Date) value);
            else {
                strDate = (String) value;
                StringBuffer buf = new StringBuffer(8);
                for (int j = 0; j < strDate.length(); j++) {
                    char c = strDate.charAt(j);
                    if (Character.isDigit(c))
                        buf.append(c);
                }

                if (buf.length() == 6)
                    buf.insert(4, "19");

                strDate = buf.toString();
            }

            if (strDate.length() != 8)
                return null;

            switch (i) {
                case 0 :
                    return strDate.substring(0, 2);
                case 1 :
                    return strDate.substring(2, 4);
                case 2 :
                    return strDate.substring(4, 8);
                default :
                    return null;
            }
        }
    }
}