/* 
 * HiddenInput.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletRequest;

import com.eXtropia.config.Config;
import com.eXtropia.config.ConfigException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 0.1
 */
public class HiddenInput extends HtmlInput {
    public static final String CFG_USE_REQUEST = "UseRequest";

    private boolean useRequest = true;

    public HiddenInput() {
        super("HIDDEN");
    }

    public void configure(Config config) throws ConfigException {
        super.configure(config);
        if (config.hasChild(CFG_USE_REQUEST)) {
            useRequest = config.getChild(CFG_USE_REQUEST).getBooleanValue();
        }
        // not sure why HtmlInput needs to appending attributes to generate the
        // html
        // eg. if I specified UseRequest=false
        // the html generated will be
        // <input type="hidden" name="XXX" value="XXX" UseRequest="false">
        //                                             ^^^^^^^^^^^^^^^^^^^
        // so I have to remove it manually
        List l = new ArrayList();
        for (int i = 0; i < _attributes.length; i++) {
            if (!_attributes[i].key.equals(CFG_USE_REQUEST)) {
                l.add(_attributes[i]);
            }
        }
        _attributes = new Attribute[l.size()];
        l.toArray(_attributes);

    }
    protected Object selectValueToUse(Object value, ServletRequest request) {
        if (useRequest) {
            return super.selectValueToUse(value, request);
        }
        return value;
    }
}