/*
 * HtmlMoneyPlainText.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.Locale;

import javax.servlet.ServletRequest;

import com.eXtropia.config.Config;
import com.eXtropia.config.ConfigException;

/**
* Describe class <code>HtmlMoneyPlainText</code> here.
*
* @author <a href="mailto:st_lim@3ui.com">Lim Swee Tat</a>
* @version $Id: HtmlMoneyPlainText.java,v 1.4 2002/11/16 08:45:15 rayfd Exp $
*/
public class HtmlMoneyPlainText extends HtmlPlainText {
    /**
     * Describe <code>configure</code> method here.
     *
     * @param config a <code>Config</code> value
     * @exception ConfigException if an error occurs
     */
    public void configure(Config config) throws ConfigException {
        super.configure(config);
    }

    /**
     * Describe <code>toString</code> method here.
     *
     * @param locale a <code>Locale</code> value
     * @param value an <code>Object</code> value
     * @param request a <code>ServletRequest</code> value
     * @param idSuffix a <code>String</code> value
     * @return a <code>String</code> value
     */
    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        return toString(locale, value, request);
    }

    /**
     * Describe <code>toString</code> method here.
     *
     * @param locale a <code>Locale</code> value
     * @param value an <code>Object</code> value
     * @param request a <code>ServletRequest</code> value
     * @return a <code>String</code> value
     */
    public String toString(Locale locale, Object value, ServletRequest request) {
        BigDecimal newValue = null;
        if (value instanceof BigDecimal) {
            newValue = (BigDecimal) value;
        } else if (value instanceof String) {
            newValue = new BigDecimal((String) value);
        } else if (value instanceof java.lang.Number) {
            newValue = new BigDecimal(((java.lang.Number) value).doubleValue());
        }

        newValue.setScale(2, BigDecimal.ROUND_UP);
        String newStringValue;
        //MessageFormat mf = new MessageFormat("#,###.00"); // NumberFormat.getCurrencyInstance();

        newStringValue = MessageFormat.format("{0,number,#,###.00}", new Object[] { newValue });
        return super.toString(locale, newStringValue, request);

    }
} // HtmlMoneyPlainText
