/* 
 * Image.java
 * Copyright (C) 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.servlet.ServletRequest;

import com.eXtropia.config.Config;
import com.eXtropia.config.ConfigException;
import com.eXtropia.view.widget.Widget;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class Image extends Widget {
    public static final String RESOURCE_ALT = ".alt";

    public static final String CFG_BORDER = "Border";

    protected int _border = 0;

    public void configure(Config config) throws ConfigException {
        super.configure(config);
        if (config.hasChild(CFG_BORDER))
            _border = config.getChild(CFG_BORDER).getIntValue();
    }

    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        return toString(locale, value, request);
    }

    public String toString(Locale locale, Object value, ServletRequest request) {
        StringBuffer buffer = new StringBuffer();
        buffer.append("<IMAGE SRC=\"");
        if (value != null)
            buffer.append(value);
        buffer.append("\" ALT=\"");
        ResourceBundle bundle = ResourceBundle.getBundle(_resourceLocation, locale);
        try {
            buffer.append(bundle.getString(_resourceBase + RESOURCE_ALT));
        } catch (MissingResourceException mre) {
            buffer.append(_resourceLocation + RESOURCE_ALT);
        }
        buffer.append("\" BORDER=\"");
        buffer.append(_border);
        buffer.append("\">");
        return buffer.toString();
    }
}