/* 
 * TextArea.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.util.Locale;

import javax.servlet.ServletRequest;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class TextArea extends HtmlInput {
    /** Creates new TextArea */
    public TextArea() {
        super("TEXTAREA");
    }

    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        value = selectValueToUse(value, request);

        StringBuffer buffer = new StringBuffer(100);
        buffer.append("<TEXTAREA name=\"");
        buffer.append(_id);
        if (idSuffix != null)
            buffer.append(idSuffix);
        buffer.append('\"');
        appendAttributes(buffer);
        buffer.append('>');
        buffer.append(value == null ? "" : value.toString());
        buffer.append("</TEXTAREA>");
        return buffer.toString();
    }

    public String toString(Locale locale, Object value, ServletRequest request) {
        return toString(locale, value, request, null);
    }
}