/* 
 * TrueFalseCheckbox.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.view.widget.html;

import java.util.Locale;

import javax.servlet.ServletRequest;

import com.eXtropia.config.Config;
import com.eXtropia.config.ConfigException;
import com.eXtropia.datahandler.handler.BooleanHandler;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class TrueFalseCheckbox extends HtmlInput {
    public TrueFalseCheckbox() {
        super("CHECKBOX");
    }

    public void configure(Config config) throws ConfigException {
        super.configure(config);
        BooleanHandler handler = new BooleanHandler();
        handler.setIds(new String[] { _id });
        addDataHandler(handler);
    }

    public String toString(Locale locale, Object value, ServletRequest request, String idSuffix) {
        value = selectValueToUse(value, request);

        if (value == null) {
            value = Boolean.FALSE;
        } else if (!(value instanceof Boolean)) {
            value = Boolean.valueOf(value.toString());
        }

        StringBuffer buffer = new StringBuffer(50);
        buffer.append("<INPUT TYPE=\"");
        buffer.append(_type);
        buffer.append("\" NAME=\"");
        buffer.append(_id);
        if (idSuffix != null)
            buffer.append(idSuffix);
        buffer.append("\" VALUE=\"true\"");
        appendAttributes(buffer);
        if (value.equals(Boolean.TRUE)) {
            buffer.append(" CHECKED");
        }
        buffer.append('>');
        return buffer.toString();
    }

    public String toString(Locale locale, Object value, ServletRequest request) {
        return toString(locale, value, request, null);
    }
}