/* 
 * EventOccurrence.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal;

import java.util.Date;

/** 
 * A class representing the start and end dates of a particular instance of an <CODE>Event</CODE>
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class EventOccurrence implements Comparable {
    private Event _event;
    private Date _startDate;
    private Date _endDate;

    public EventOccurrence(Event event, Date startDate, Date endDate) {
        _event = event;
        _startDate = startDate;
        _endDate = endDate;
    }

    public Date getEndDate() {
        return _endDate;
    }

    public Event getEvent() {
        return _event;
    }

    public Date getStartDate() {
        return _startDate;
    }

    public int compareTo(final java.lang.Object p1) {
        EventOccurrence occurrence2 = (EventOccurrence) p1;
        return _startDate.compareTo(occurrence2._startDate);
    }
}