/* 
 * Delete.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.app.servlet.Views;
import com.eXtropia.diagnostics.LogEvent;
import com.eXtropia.util.ExtropiaException;
import com.eXtropia.webcal.Task;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class Delete extends WebCalAction {
    public Delete() {
    }

    public boolean requiresData() {
        return false;
    }

    public UserGestureResponse execute(UserGesture g, ServletRequest request) throws ExtropiaException {
        WebCalUserGesture gesture = (WebCalUserGesture) g;
        //can only delete if we have the appropriate permissions
        WebCalUserGestureResponse response = new WebCalUserGestureResponse();
        Task task = _dataSource.loadById(gesture.getId());
        if (task != null) {
            if (gesture.getUser().getId().equals(task.getOwner().getId())) {
                _dataSource.delete(gesture.getId());
                _doctor.log(new LogEvent(this, LogEvent.INFO, "User " + gesture.getUser().getId() + " has deleted task: " + task.getId()));
            } else {
                _doctor.log(new LogEvent(this, LogEvent.WARN, "User " + gesture.getUser().getId() + " is not allowed to delete a task owned by:  " + task.getOwner().getId()));
                response.setView(Views.UNAUTHORIZED);
                return response;
            }
        }
        return null;
    }
}