/* 
 * LoadHolidays.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import java.util.Calendar;
import java.util.Date;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.util.ExtropiaException;
import com.eXtropia.webcal.Task;
import com.eXtropia.webcal.Utilities;
import com.eXtropia.webcal.datasource.DataSourceColumns;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class LoadHolidays extends WebCalAction {
    public static final String DEFAULT_SORT_COLUMN = DataSourceColumns.START_DATE;

    public LoadHolidays() {
    }

    public UserGestureResponse execute(UserGesture g, ServletRequest request) throws ExtropiaException {
        WebCalUserGesture gesture = (WebCalUserGesture) g;
        int year = gesture.getHy();
        Calendar cal = Calendar.getInstance();
        cal.clear();
        cal.set(Calendar.YEAR, year);
        cal.set(Calendar.MONTH, 0);
        cal.set(Calendar.DATE, 1);
        Date startDate = cal.getTime();
        cal.add(Calendar.YEAR, 1);
        cal.add(Calendar.SECOND, -1);
        Date endDate = cal.getTime();
        WebCalUserGestureResponse response = new WebCalUserGestureResponse();
        //System.out.println("loading between: " + startDate + " => " + endDate);
        Task[] tasks = _dataSource.loadHolidays(startDate, endDate);
        response.setTasks(tasks);
        //System.out.println("loaded: " + tasks.length);
        response.setEventOccurrences(Utilities.generateEventOccurrences(tasks, startDate, endDate), startDate, endDate);
        response.setView(g.getView());
        return response;
    }
}