/* 
 * PrepareAddAppointment.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import java.util.Calendar;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.util.ExtropiaException;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class PrepareAddAppointment extends WebCalAction {
    public PrepareAddAppointment() {
    }

    public UserGestureResponse execute(UserGesture g, ServletRequest request) throws ExtropiaException {
        WebCalUserGesture gesture = (WebCalUserGesture) g;
        if (gesture.getAction() != null) {
            WebCalUserGestureResponse gr = new WebCalUserGestureResponse();
            gr.setView(gesture.getView());
            return gr; // only do this when going to the screen the first time
        }

        Calendar cal = Calendar.getInstance();
        int hour = cal.get(Calendar.HOUR_OF_DAY) + 1;
        cal.setTime(gesture.getFocusDate());
        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH);
        int date = cal.get(Calendar.DATE);

        //edit the request to make sure that the appropriate time defaults are present
        try {
            hour = Integer.parseInt(request.getParameter(UrlParams.START_DATE + "_h"));
        } catch (Exception e) {
        }

        try {
            date = Integer.parseInt(request.getParameter(UrlParams.START_DATE + "_d"));
        } catch (Exception e) {
        }

        try {
            month = Integer.parseInt(request.getParameter(UrlParams.START_DATE + "_M"));
            month--;
        } catch (Exception e) {
        }

        try {
            year = Integer.parseInt(request.getParameter(UrlParams.START_DATE + "_y"));
        } catch (Exception e) {
        }

        cal.clear();
        cal.set(Calendar.YEAR, year);
        cal.set(Calendar.MONTH, month);
        cal.set(Calendar.DATE, date);
        cal.set(Calendar.HOUR_OF_DAY, hour);
        request.setAttribute(UrlParams.START_DATE, cal.getTime());

        cal.add(Calendar.HOUR_OF_DAY, 1);
        request.setAttribute(UrlParams.END_DATE, cal.getTime());

        WebCalUserGestureResponse gr = new WebCalUserGestureResponse();
        gr.setView(gesture.getView());
        return gr;
    }
}