/* 
 * Search.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.auth.User;
import com.eXtropia.datasource.FieldOrder;
import com.eXtropia.util.ExtropiaException;
import com.eXtropia.webcal.datasource.DataSourceColumns;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class Search extends WebCalAction {
    public static final String DEFAULT_SORT_COLUMN = DataSourceColumns.SUBJECT;

    public Search() {

    }

    public UserGestureResponse execute(UserGesture g, ServletRequest request) throws ExtropiaException {
        WebCalUserGesture gesture = (WebCalUserGesture) g;
        FieldOrder order;
        String sortField = gesture.getSrchSf();

        if (sortField == null)
            order = new FieldOrder(DEFAULT_SORT_COLUMN);
        else
            order = new FieldOrder(sortField, gesture.getSa() ? FieldOrder.ASCEND : FieldOrder.DESCEND);

        WebCalUserGestureResponse response = new WebCalUserGestureResponse();
        User[] users = new User[2];
        users[0] = gesture.getUser();
        users[1] = _globalUser;
        if (gesture.getSk() != null) {
            //then the user submitted the search instead of just going to the search screen
            response.setTasks(_dataSource.load(users, gesture.getSt(), gesture.getSk() == null ? "" : gesture.getSk(), order));
            //System.out.println("Search returned: " + response.getTasks().length);
        }
        response.setView(gesture.getView());
        return response;
    }
}