/* 
 * WebCalUserGestureFactory.java
 * Copyright (C) 2000 -2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import javax.servlet.ServletRequest;

import com.eXtropia.app.UserGesture;
import com.eXtropia.app.servlet.UserGestureFactory;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class WebCalUserGestureFactory extends UserGestureFactory {
    public UserGesture create(ServletRequest request) {
        UserGesture gesture = super.create(request);
        WebCalUserGesture g = new WebCalUserGesture();
        String val;
        g.setAction(gesture.getAction());
        g.setTargetView(gesture.getTargetView());
        g.setView(gesture.getView());
        g.setFd(request.getParameter(WebCalUserGesture.PARAM_FOCUS_DATE));
        g.setTaskSf(request.getParameter(WebCalUserGesture.PARAM_TASK_SORT_FIELD));
        g.setSrchSf(request.getParameter(WebCalUserGesture.PARAM_SEARCH_SORT_FIELD));
        val = request.getParameter(WebCalUserGesture.PARAM_SORT_ASCENDING);
        if (val != null)
            g.setSa(Boolean.valueOf(val).booleanValue());
        g.setId(request.getParameter(WebCalUserGesture.PARAM_TASK_ID));
        g.setSk(request.getParameter(WebCalUserGesture.PARAM_SEARCH_KEYWORD));
        val = request.getParameter(WebCalUserGesture.PARAM_SEARCH_TYPES);
        if (val != null)
            g.setSt(Integer.parseInt(val));
        val = request.getParameter(WebCalUserGesture.PARAM_HOLIDAY_YEAR);
        if (val != null)
            g.setHy(Integer.parseInt(val));
        return g;
    }
}