/* 
 * WebCalUserGestureResponse.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.action;

import java.util.Date;

import com.eXtropia.app.UserGestureResponse;
import com.eXtropia.util.ExtropiaException;
import com.eXtropia.webcal.EventOccurrence;
import com.eXtropia.webcal.Task;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class WebCalUserGestureResponse extends UserGestureResponse {
    protected Task[] _tasks;
    protected EventOccurrence[] _eventOccurrences;
    protected Date _startDate, _endDate;

    /** Creates new WebCalUserGestureResponse */
    public WebCalUserGestureResponse() {

    }

    public WebCalUserGestureResponse(String view) {
        super(view);
    }

    public WebCalUserGestureResponse(String view, ExtropiaException error) {
        super(view, error);
    }

    public Date getOccurrenceStartDate() {
        return _startDate;
    }

    public Date getOccurrenceEndDate() {
        return _endDate;
    }

    public Task[] getTasks() {
        return _tasks;
    }

    public void setTasks(Task[] tasks) {
        _tasks = tasks;
    }

    public EventOccurrence[] getEventOccurrences() {
        return _eventOccurrences;
    }

    public void setEventOccurrences(EventOccurrence[] eventOccurrences, Date startDate, Date endDate) {
        _eventOccurrences = eventOccurrences;
        _startDate = startDate;
        _endDate = endDate;
    }
}