/* 
 * Recurring.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.recurrence;

import java.util.Date;

import com.eXtropia.webcal.EventOccurrence;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public interface Recurring {
    /**
     * @return how the recurrence occurs
     */
    public RecurrencePattern getRecurrencePattern();

    /**
     * Sets the how the recurrence occurs
     * @param recurrencePattern how the recurrence occurs
     */
    public void setRecurrencePattern(RecurrencePattern recurrencePattern);

    /**
     * Gets an array of occurrences of the Event between the given dates
     * @param startDate the first date an occurrence may start on
     * @param endDate the last date an occurrence may start on
     * @return an array of all occurrences between the start and end dates
     */
    public EventOccurrence[] getOccurrences(Date startDate, Date endDate);
}