/* 
 * AddUrlNavigationTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.view;

import java.util.Calendar;
import java.util.Date;
import java.util.Map;

import com.eXtropia.view.UrlNavigationTag;
import com.eXtropia.view.ViewManager;
import com.eXtropia.webcal.action.UrlParams;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class AddUrlNavigationTag extends UrlNavigationTag {
    protected Date _date;
    protected int _hour;

    protected Map getRequestParams() {
        Map map = super.getRequestParams();
        if (_date != null) {
            Calendar cal = Calendar.getInstance();
            cal.setTime(_date);
            map.put(UrlParams.START_DATE + "_d", new Integer(cal.get(Calendar.DATE)));
            map.put(UrlParams.START_DATE + "_M", new Integer(cal.get(Calendar.MONTH) + 1));
            map.put(UrlParams.START_DATE + "_y", new Integer(cal.get(Calendar.YEAR)));
        }
        if (_hour > -1)
            map.put(UrlParams.START_DATE + "_h", new Integer(_hour));
        map.put(ViewManager.VIEW_ATTRIBUTE_NAME, WebCalViews.ADD);
        return map;
    }

    public void setDate(Date date) {
        _date = date;
    }

    public void setHour(int hour) {
        _hour = hour;
    }

    public void release() {
        _hour = -1;
        _date = null;
    }
}