/* 
 * DeleteTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.view;

import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.Tag;

import com.eXtropia.view.FormNavigationTag;
import com.eXtropia.view.NextTag;
import com.eXtropia.webcal.Task;
import com.eXtropia.webcal.action.Actions;
import com.eXtropia.webcal.action.WebCalUserGesture;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class DeleteTag extends FormNavigationTag {
    protected Task _task;

    public int doStartTag() throws JspException {
        Tag tag = this;
        tag = this;
        while (_task == null && tag != null) {
            if (tag instanceof NextTag && ((NextTag) tag).getIterator() instanceof TaskIteratorTag)
                _task = (Task) ((NextTag) tag).getObject();
            else
                tag = tag.getParent();
        }
        return super.doStartTag();
    }

    protected Map getRequestParams() {
        Map map = super.getRequestParams();
        map.put(WebCalUserGesture.ACTION_REQUEST_PARAM_NAME, Actions.DELETE);
        if (_task != null)
            map.put(WebCalUserGesture.PARAM_TASK_ID, _task.getId());
        return map;
    }

    public void release() {
        super.release();
        _task = null;
    }
}