/* 
 * DetailsTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.view;

import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.Tag;

import com.eXtropia.view.NextTag;
import com.eXtropia.view.UrlNavigationTag;
import com.eXtropia.webcal.Event;
import com.eXtropia.webcal.EventOccurrence;
import com.eXtropia.webcal.Holiday;
import com.eXtropia.webcal.Task;
import com.eXtropia.webcal.action.WebCalUserGesture;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class DetailsTag extends UrlNavigationTag {
    protected Task _task;

    public int doStartTag() throws JspException {
        Tag tag = this;
        tag = this;
        while (_task == null && tag != null) {
            if (tag instanceof NextTag && (((NextTag) tag).getIterator() instanceof TaskIteratorTag || ((NextTag) tag).getIterator() instanceof EventOccurrenceIteratorTag)) {
                if (((NextTag) tag).getIterator() instanceof TaskIteratorTag)
                    _task = (Task) ((NextTag) tag).getObject();
                else
                    _task = ((EventOccurrence) ((NextTag) tag).getObject()).getEvent();
            } else
                tag = tag.getParent();
        }
        return super.doStartTag();
    }

    protected Map getRequestParams() {
        Map map = super.getRequestParams();
        if (_task != null) {
            map.put(WebCalUserGesture.PARAM_TASK_ID, _task.getId());
            if (_task instanceof Holiday)
                map.put(WebCalUserGesture.VIEW_REQUEST_PARAM_NAME, WebCalViews.MODIFY_HOLIDAY);
            else if (_task instanceof Event)
                map.put(WebCalUserGesture.VIEW_REQUEST_PARAM_NAME, WebCalViews.MODIFY);
            else
                map.put(WebCalUserGesture.VIEW_REQUEST_PARAM_NAME, WebCalViews.MODIFY_TASK);
        }
        return map;
    }

    public void release() {
        _task = null;
    }

    public void setTask(Task task) {
        _task = task;
    }
}