/* 
 * SortTasksTag.java
 * Copyright (C) 2000 - 2001  eXtropia.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.eXtropia.webcal.view;

import java.util.Map;

import com.eXtropia.view.UrlNavigationTag;
import com.eXtropia.webcal.action.WebCalUserGesture;

/** 
 *
 * @author  Tim Parker (tim.parker@eXtropia.com)
 * @version 1.0
 */
public class SortTasksTag extends UrlNavigationTag {
    protected String _field;
    protected boolean _ascending = true;

    public boolean getAscending() {
        return _ascending;
    }

    protected Map getRequestParams() {
        Map map = super.getRequestParams();
        map.remove(WebCalUserGesture.ACTION_REQUEST_PARAM_NAME);
        map.put(WebCalUserGesture.PARAM_TASK_SORT_FIELD, _field);
        map.put(WebCalUserGesture.PARAM_SORT_ASCENDING, new Boolean(_ascending));
        return map;
    }

    public String getSortField() {
        return _field;
    }

    public void setAscending(boolean ascending) {
        _ascending = ascending;
    }

    public void setSortField(String sortField) {
        _field = sortField;
    }

    public void release() {
        _field = null;
        _ascending = true;
    }
}